//----------------------------------------------------------------
// This tutorial was written by ben
//----------------------------------------------------------------
#pragma comment(lib, "d3d9.lib")
#include <windows.h>
#include <d3d9.h>
LPDIRECT3D9 m_D3D = NULL;
LPDIRECT3DDEVICE9 m_D3DD = NULL;
HRESULT D3D9Init(HWND hWnd)
{
	m_D3D = Direct3DCreate9( D3D_SDK_VERSION );
	if(m_D3D == NULL)
	{
		MessageBox(0, "D3D create failed", "error", 0);
		return E_FAIL;
	}
	D3DPRESENT_PARAMETERS d3dpm;
	ZeroMemory(&d3dpm, sizeof(d3dpm));
	d3dpm.BackBufferFormat = D3DFMT_UNKNOWN;
	d3dpm.Windowed = TRUE;
	d3dpm.SwapEffect = D3DSWAPEFFECT_DISCARD;

	if(FAILED(m_D3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpm, &m_D3DD)))
	{
		MessageBox(0, "D3D Device creation failed", "error", 0);
		return E_FAIL;
	}
	return S_OK;
}
void Render()
{
	m_D3DD->Clear(0, 0, D3DCLEAR_TARGET, D3DCOLOR_XRGB(0,0,255), 1.0f, 0);
	m_D3DD->BeginScene();
	m_D3DD->EndScene();
	m_D3DD->Present(0,0,0,0);
}
HRESULT APIENTRY WinProc(HWND hWnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	switch(msg)
	{
	case WM_CLOSE:
		PostQuitMessage(0);
	case WM_PAINT:
		Render();
	}
	return DefWindowProc(hWnd, msg, wparam, lparam);
}

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE, LPSTR, int)
{
	WNDCLASSEX wc;
	wc.cbClsExtra = 0;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.cbWndExtra = 0;
	wc.hbrBackground = 0;
	wc.hCursor = 0;
	wc.hIcon = 0;
	wc.hIconSm = 0;
	wc.hInstance = hInst;
	wc.lpfnWndProc = WinProc;
	wc.lpszClassName = "D3D9TUT";
	wc.lpszMenuName = 0;
	wc.style = CS_CLASSDC;
	RegisterClassEx(&wc);

	HWND hWnd = CreateWindow("D3D9TUT", "Direct3D9 Tutorial", WS_OVERLAPPEDWINDOW, 100, 100, 300, 300, 0, 0, wc.hInstance, 0);

	if(SUCCEEDED(D3D9Init(hWnd)))
	{
		ShowWindow(hWnd,10);
		UpdateWindow(hWnd);
		MSG msg;
		ZeroMemory(&msg, sizeof(msg));
		while(msg.message != WM_QUIT)
		{
			if(GetMessage(&msg,0,0,0))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
}